//
//  main.swift
//  Brighme
//
//  Created by Super User on 02/11/14.
//  Copyright (c) 2014 Super User. All rights reserved.
//

import Foundation

private func setBrightnessLevel(level: Float) {
    var iterator: io_iterator_t = 0
    
    let result = IOServiceGetMatchingServices(kIOMasterPortDefault,
        IOServiceMatching("IODisplayConnect").takeUnretainedValue(),
        &iterator)
    
    if result == kIOReturnSuccess {
        var service: io_object_t = 1
        var value: Float = 0.0
        var err = kIOReturnSuccess
        var errDesc: String
        for ;; {
            service = IOIteratorNext(iterator)
            
            if service == 0 {
                break
            }
            
            
            err = IODisplayGetFloatParameter(service, 0, kIODisplayBrightnessKey, &value)
            if !(err == kIOReturnSuccess) {
                errDesc = String.fromCString(strerror(err))!
                println("Kernel error: \(err) - \(errDesc)")
            } else {
                println("Current brightness level is \(value)")
            }
            err = IODisplaySetFloatParameter(service, 0, kIODisplayBrightnessKey, level)
            if !(err == kIOReturnSuccess) {
                errDesc = String.fromCString(strerror(err))!
                println("Kernel error: \(err) - \(errDesc)")
            }
            IOObjectRelease(service)
        }
    }
}
setBrightnessLevel(0.37)

// Used just to check that the code prints the srerror correctly
for i: Int32 in 1...10 {
    println("Kernel error \(i): \( String.fromCString(strerror(i)))")
}

